#define YY_DEFAULT_ACTION ECHO;
#define FLEX_USE_ECS
#define FLEX_USE_MECS
/* A lexical scanner generated by flex */

#include "skeldef.h"

# line 1 "xfmt.l"
#define INITIAL 0
# line 2 "xfmt.l"

/* 
 * (was file: fmt.c)
 * 04/88  bgray
 * file: xfmt.l
 * revised with (f)lex front end
 * 05/88  Greg Lee
 */

/* a simple text formatter */

#ifndef lint
static	char xfmt_sccsid[] = "@(#)xfmt.l <05/30/88>";
#endif lint


#include <stdio.h>
#include <ctype.h>
#include <string.h>

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

/* character attributes controlled by font-changing commands */
#define ROMAN  1	/* plain, from \rm or .R */
#define ITALIC 2	/* underlined, from \it or .I */
#define BOLD   3	/* bold, from \bf or .B */
#define TTYPE  4	/* reversed, from \tt or .S */
#define SLANTY 5	/* blinking, from \sl or .G */

int     attribute = ROMAN,	/* current character attribute */
        nextattribute = 0;	/* attribute to restore after next
				 * word for .RB, etc. or after line
				 * for \beginsection
				 */
char    nest[80];		/* stack of attributes for each current */
int	level = 1;		/* TeX {}-group */

/* global state of formatter */
char    iflag  = FALSE,		/* preserving left indentation (-i)? */
        jflag  = FALSE,		/* requested justification with -j? */
        oflag  = FALSE,		/* requested overprint with -o? */
        uflag  = FALSE,		/* requested terminal output with -u? */
        xflag  = FALSE,		/* requested use TeX commands w. -x? */
        mflag  = FALSE,		/* requested use man commands w. -m? */
        cflag  = FALSE,		/* requested format C code w. -c? */
        qtflag = FALSE,		/* saw odd " in processing .RB etc.? */
        ceflag = FALSE,		/* center next output line? */
        raflag = FALSE,		/* right adjust next output line? */
        obflag = FALSE,		/* not concatenating? */
        njflag = FALSE;		/* not currently justifying? */

int     maxlen  = 72,
        tabsize = 8,
        indent  = 0,
        offset  = 0,
        tpstate = 0,		/* keep track for hanging indentation */
        tpvalue = 5,		/* amount of hang, from arg of .TP,.HP */
        spaces  = 0,		/* space to leave after current word */
        tempi;			/* misc. use in lex pattern section */

char   *progname = NULL;
char   *usage = "usage: %s [-ijcmxou] [-l n] [-p n] [-t n] [file ...]\n";

int     dir = FALSE;
int     holecnt = 0;
char   *holeptr[256];		/* holeptr[0] is unused */

char	oline[2048] = "\0",	/* output line buffer */
       *olp = oline,
        aline[2048] = "\0",	/* output line attribute buffer */
       *alp = aline,
        oword[512] = "\0",	/* output word buffer */
       *owp = oword,
        aword[512] = "\0",	/* output word attribute buffer */
       *awp = aword;

extern char *optarg;		/* from getopt */
extern int  optind;

int     max ();
void    exit ();
char   *basename ();
void    copyindent ();
void    puttc ();
void    putts ();
void    lbreak ();
void    putword ();
void    justifyline ();
void    putline ();
void    sputline ();
void    skipline ();
void    addparens ();
void    terminit ();
void    termattr ();

/* lex start state for flags: -x, -m, (none), -mx, respectively */
#define TEX 2
#define MAN 4
#define PLAIN 6
#define ALL 8
#define CCODE 10
/* match end of TeX command */
# line 110 "xfmt.l"
#define YY_JAM 453
#define YY_JAM_BASE 1848
#define YY_TEMPLATE 454
static char l[454] =
    {   0,
       -2,   -2,   -2,   -2,   -2,   -2,   -2,   -2,   -2,   -2,
       -2,   -2,   91,   65,   66,   66,   26,   63,   69,   68,
       24,   25,   64,   28,   62,   61,   91,   26,   91,    5,
       28,   91,   80,   91,   91,   91,   90,   90,   90,   90,
       90,   90,   90,   90,   90,   90,   90,   90,   90,   90,
       90,   90,   65,    3,   26,   27,    6,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,   35,   34,   34,
       35,   35,   35,   35,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,   38,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    5,   27,    6,   35,

       35,    6,   34,   35,   34,   35,   35,   35,   35,   34,
       35,   34,    0,    0,    0,    0,    0,    0,   82,   81,
       90,   90,   90,   90,   90,   90,   90,   83,   90,   90,
       90,   90,   90,   90,   84,   90,   90,   90,   90,   90,
       90,   90,   90,   90,   90,   90,   70,   70,   70,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,   75,   12,    8,   10,   14,   16,
        0,   74,   29,    0,    0,   30,    0,   44,   76,   45,
       33,    0,    0,   43,    0,   38,    0,   46,   79,   78,
       31,    0,    0,   32,    0,    0,    0,    0,   59,   58,

       60,   37,   23,   22,    1,    0,    0,   12,    8,   10,
       14,   16,   70,   70,    0,    0,    0,   88,    0,    0,
        0,   90,   90,   90,   90,   90,   90,   90,   90,   90,
       90,   90,   90,   86,   90,   90,   90,   90,   90,   90,
       90,   90,   90,   90,   90,   90,   90,   70,    0,    0,
        0,   11,   11,   11,    0,    7,    7,    7,    0,    0,
        0,    0,   13,   13,   13,    9,    9,    9,   15,   15,
       15,   73,    0,    0,   50,   48,    0,    0,   52,   43,
       43,   47,   56,   46,   79,   78,   51,   49,   54,   55,
        0,   42,    0,    0,   58,   60,    0,   77,    0,    0,

        0,    0,    0,    0,    0,    0,    0,   85,   90,   90,
       90,   90,   90,   90,   83,   90,   90,   90,   90,   90,
       90,   90,   90,   90,   90,   87,   90,   17,   17,   17,
        0,    0,    0,    0,    0,    0,    0,    0,   72,   71,
       57,    0,   41,    0,   56,   54,   55,    0,   59,    4,
       77,    0,    0,   89,    0,    0,    0,    0,    0,   90,
       90,   90,   90,   90,   90,   90,   90,   90,   90,   90,
       90,    0,    0,    0,    0,   40,   40,   40,    0,    0,
        0,    0,   39,   39,   36,    0,   88,    0,    0,   90,
       90,   90,   90,   90,    2,    2,    2,    0,    0,    0,

        0,    0,    0,    0,    0,   90,   90,   90,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,   67,   67,
       67,    0,    0,   21,   21,   21,    0,   19,   19,   19,
        0,   18,   18,   18,    0,    0,   20,   20,   20,   53,
       53,   53,    0
    } ;

static char e[128] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    4,    4,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    5,    6,    7,    8,    9,   10,   10,   10,   11,
        1,   12,   13,    1,   14,   15,   16,   17,   17,   17,
       17,   17,   17,   17,   17,   17,   17,    1,    1,    1,
        1,    1,    1,    1,   18,   19,   20,   21,   22,   18,
       23,   24,   25,   18,   18,   26,   27,   28,   18,   29,
       18,   30,   31,   32,   33,   34,   18,   35,   18,   18,
        1,   36,    1,   37,   38,    1,   39,   40,   41,   42,

       43,   44,   45,   46,   47,   48,   49,   50,   51,   52,
       53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
       63,   64,   65,    6,   66,   67,    1
    } ;

static char m[68] =
    {   0,
        1,    1,    2,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    1,    1,    3,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    1,    1,    1
    } ;

static short int b[489] =
    {   0,
        0,    4,    8,   16,   24,   30,   36,   44,   82,  148,
      215,   48, 1848,   49, 1845, 1848,   53, 1844, 1848,  278,
     1848, 1848, 1848, 1843,   59, 1848,  343,   60,  391,    0,
     1842,  449, 1848,   65, 1828, 1831,    0, 1783, 1785,   49,
       25,   42,   19, 1787,   19, 1786, 1795,   52, 1774, 1784,
     1782, 1788,   74, 1848,   75, 1848, 1848,  516, 1790,  545,
       57, 1789, 1773, 1790,   58, 1779, 1770, 1848, 1848, 1848,
        0,   11,   97,   89,  106,   25,  101,    1, 1822, 1797,
      116, 1796, 1793,  107,  109,  139,  135,   90, 1803,  103,
     1815, 1765, 1773, 1775, 1764,  121,    0, 1848, 1848,    0,

     1774, 1848,    0,  128, 1773,  156,    0, 1757, 1774,  126,
      333, 1755,  346, 1769,   91,  130, 1764, 1758, 1848, 1848,
        0, 1751, 1765, 1750, 1767, 1753, 1760, 1744, 1745, 1742,
     1742, 1746, 1742, 1739,    0, 1738, 1743,  133, 1741, 1729,
      141, 1745, 1737,  136, 1743, 1742, 1848,  187,    0, 1753,
     1738, 1745, 1740,  609, 1732,  676, 1740, 1737, 1736,  743,
      810,  877,    0,  138, 1848, 1848, 1848, 1848, 1848, 1848,
     1763, 1848, 1848, 1774, 1773, 1848, 1772, 1848, 1848, 1848,
     1848, 1771, 1770,  193, 1769, 1848, 1768,    0,    0,    0,
     1848, 1767, 1766, 1848, 1765, 1764, 1763,  196,    0,    0,

        0, 1848, 1848, 1848, 1762, 1761, 1760,    0,    0,    0,
        0,    0, 1747, 1848, 1719, 1705, 1719,  148, 1719, 1707,
     1716, 1704, 1717, 1712, 1698, 1695, 1713, 1711, 1707, 1698,
     1705, 1708, 1693,    0, 1700, 1697, 1684, 1686, 1698, 1682,
     1680, 1680, 1694, 1683, 1688, 1692, 1683,  944, 1685, 1682,
     1683, 1848,  200,    0, 1671, 1848,  201,    0, 1677, 1664,
     1681, 1679, 1848,  202,    0, 1848,  206,    0, 1848,  207,
        0, 1848, 1669, 1668, 1848, 1848,    0,  349, 1848,  287,
     1848, 1848,    0,    0,    0,    0, 1848, 1848,    0,    0,
     1719, 1848,  350,    0,    0,    0, 1704,    0, 1707, 1672,

     1675, 1670, 1673, 1673, 1664, 1670, 1669,    0, 1662, 1663,
     1650, 1658, 1651, 1648,    0, 1648, 1648, 1645, 1649, 1654,
     1659, 1658, 1656, 1645, 1651,    0, 1652, 1848,  289,    0,
     1640, 1636, 1640, 1648, 1011, 1640, 1646, 1630, 1848, 1848,
     1848, 1684, 1848,  353,    0,    0,    0,  354, 1848, 1669,
        0, 1668, 1632, 1848, 1639, 1638, 1638, 1621, 1635, 1626,
     1627, 1633, 1623, 1616, 1621, 1628, 1630, 1583, 1591, 1590,
     1577, 1078,  309, 1568, 1561, 1848,  358,    0, 1540, 1547,
     1548, 1532, 1848, 1848, 1561, 1531, 1848, 1526, 1521, 1498,
      533,  404,  402,  402, 1848,  359,    0,  405,  319,  392,

      398,  388,  383,  391,  394,  393,  378,  391,  375,  389,
      382,  377,  383,  357,  346,  323,  332,  329,  332,  308,
      250,  250, 1145,  237,  167, 1212,  123, 1279, 1848,  371,
        0,  101, 1346, 1848,  372,    0,   35, 1848,  373,    0,
        4, 1848,  389,    0, 1413, 1480, 1848,  390,    0, 1848,
      401,    0, 1848, 1547, 1551, 1555, 1557, 1561, 1565, 1568,
     1572, 1576, 1580, 1584, 1588, 1592, 1596, 1600, 1603, 1606,
     1609, 1612, 1615, 1619, 1623, 1627, 1631, 1635, 1639, 1643,
     1646, 1649, 1652, 1655, 1658, 1661, 1664, 1667
    } ;

static short int d[489] =
    {   0,
      454,  454,  454,  454,  454,  454,  454,  454,  454,  454,
      453,   11,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  455,  453,  453,  456,
      453,  453,  453,  453,  453,  453,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  453,  453,  453,  453,  453,  453,   58,   58,
       60,   60,   60,   60,   60,   60,   60,  453,  453,  453,
      458,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  456,  453,  453,   58,

       58,  453,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,  453,  453,  453,  453,  453,  453,  453,  453,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  453,  459,   58,   58,
       60,   60,   60,  453,   60,  453,   60,   60,   60,  453,
      453,  453,  460,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  461,  462,  463,
      453,  453,  453,  453,  453,  453,  453,  464,  465,  466,

      467,  453,  453,  453,  453,  453,  453,   58,   58,   58,
       58,   58,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  453,   60,   60,
       60,  453,  468,   58,   60,  453,  469,   58,   60,   60,
       60,   60,  453,  470,   58,  453,  471,   58,  453,  472,
       58,  453,  453,  453,  453,  453,  473,  474,  453,  453,
      453,  453,  475,  461,  462,  463,  453,  453,  476,  477,
      464,  453,  464,  478,  466,  467,  453,  479,  453,  453,

      453,  453,  453,  453,  453,  453,  453,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  453,  480,   58,
       60,   60,   60,   60,  453,   60,   60,   58,  453,  453,
      453,  474,  453,  474,  475,  476,  477,  464,  453,  453,
      479,  453,  453,  453,  453,  453,  453,  453,  453,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  453,   60,   60,   60,  453,  481,   58,   60,   60,
       60,   58,  453,  453,  453,  453,  453,  453,  453,  457,
      457,  457,  457,  457,  453,  482,   58,   60,   60,   60,

       60,   60,   60,   58,  453,  457,  457,  457,   60,   60,
       60,   60,   60,   60,   58,   60,   60,   60,  335,   60,
       60,   58,  453,   60,   60,  453,   60,  453,  453,  483,
       58,   60,  453,  453,  484,   58,   58,  453,  485,   58,
       60,  453,  486,   58,  453,  453,  453,  487,   58,  453,
      488,   58,-32767,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453
    } ;

static short int n[1916] =
    {   0,
      453,   14,   15,   16,   14,   17,   15,   16,   17,   14,
       18,   16,   14,  453,  453,   19,   19,   17,   18,   16,
       17,  164,  180,   19,   19,   14,   24,   16,   25,  176,
       26,   17,   24,   16,   28,  180,   26,   14,   15,   16,
       14,  165,  453,   20,   29,   17,   15,   16,   17,   17,
       53,   20,   28,   53,   55,  446,  177,   55,   30,   27,
       53,   55,  135,   53,   55,   27,  113,  127,  132,  113,
      136,  133,   21,   22,   23,   53,   55,  128,   53,   55,
       21,   22,   23,   14,   31,   16,   25,  124,   26,   19,
       19,  129,  445,  130,  125,  152,  158,  139,  140,  153,

      154,  126,  171,  131,  159,  172,  114,  115,  160,  141,
      173,  116,  142,  197,  117,  166,  167,   32,  198,  168,
      176,  167,  178,  118,  200,  169,  169,  170,  188,  190,
      174,  178,  179,  200,  183,  175,  185,  186,  188,  194,
      216,  189,  217,  191,  184,  185,   21,   22,   23,   17,
       31,   16,   28,  441,   26,   19,   19,  192,  195,  206,
      178,  196,   29,  193,  158,  195,  152,  207,  437,  178,
      153,  154,  159,  218,  208,  209,  160,  236,  210,  240,
      209,  219,  244,   32,  211,  211,  212,  273,  148,  303,
      237,  148,  245,  274,  280,  281,  241,  280,  292,  304,

      293,  253,  257,  264,  253,  257,  264,  267,  270,  433,
      267,  270,   21,   22,   23,   13,   14,   31,   16,   25,
       13,   33,   34,   13,   13,   13,   35,   13,   13,   13,
       36,   13,   37,   37,   37,   37,   37,   37,   37,   37,
       37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
       13,   13,   37,   38,   39,   40,   41,   42,   43,   44,
       37,   45,   37,   37,   46,   37,   37,   37,   37,   37,
       47,   48,   49,   50,   51,   52,   37,   37,   37,   13,
       13,   13,   56,  432,   57,   57,   57,   57,  280,  281,
      329,  280,  428,  329,  427,   58,   58,   58,   58,   58,

       58,   58,   58,   58,   58,   58,   58,   58,   58,   59,
       58,   58,   58,   57,   57,   57,   60,   61,   62,   60,
       60,   60,   60,   58,   63,   60,   60,   60,   60,   60,
       64,   60,   60,   65,   66,   67,   60,   60,   60,   60,
       60,   60,   57,   57,   57,   69,  213,  113,   70,  214,
      113,  343,  292,   71,   72,  383,  384,  249,  398,  377,
      396,  410,  377,  396,  426,  344,  348,  249,  423,  344,
      348,  249,  430,  435,  439,  430,  435,  439,   60,   70,
      425,   70,  161,   70,   70,   70,   73,  114,  115,  424,
      443,  448,  116,  443,  448,  117,   70,  422,   70,   74,

       70,   70,  451,  421,  118,  451,   70,   70,   70,   75,
       76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
       86,   87,   88,   89,   90,  420,   91,  419,  418,  417,
       92,  416,  326,  234,   93,  315,  387,  415,  414,  413,
      412,  411,   94,  409,  408,  326,  407,   95,   96,   68,
       68,   69,   68,   98,   70,   99,   99,   99,   99,   71,
       72,   68,   68,   68,   68,   68,  100,  100,  100,  100,
      100,  100,  100,  100,  100,  100,  100,  100,  100,  100,
      101,  100,  100,  100,   99,  102,   99,  103,  104,  105,
      103,  103,  106,  107,  100,  108,  107,  107,  107,  107,

      107,  109,  103,  107,  110,  111,  112,  103,  107,  107,
      107,  107,  103,  102,  102,   99,  147,  148,  147,  147,
      148,  147,  147,  147,  147,  147,  147,  147,  147,  147,
      147,  147,  147,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  147,  147,  147,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
      147,  147,  147,   60,   60,   60,   60,   60,   60,   60,
      315,   60,   60,   60,   60,   60,   60,   60,   60,   60,

       60,  151,   60,   60,   60,   60,   60,   60,   60,  252,
      253,  252,  252,  253,  252,  252,  252,  252,  252,  252,
      252,  252,  252,  252,  252,  252,  254,  254,  254,  254,
      254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
      254,  254,  254,  254,  252,  252,  252,   60,   60,   60,
       60,   60,   60,   60,   58,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   60,  151,   60,   60,   60,   60,
       60,   60,   60,  252,  252,  252,  256,  257,  256,  256,
      257,  256,  256,  256,  256,  256,  256,  256,  256,  256,
      256,  256,  256,  258,  258,  258,  258,  258,  258,  258,

      258,  258,  258,  258,  258,  258,  258,  258,  258,  258,
      258,  256,  256,  256,   60,   60,   60,   60,  259,   60,
       60,   58,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,  151,   60,   60,   60,   60,   60,   60,   60,
      256,  256,  256,  263,  264,  263,  263,  264,  263,  263,
      263,  263,  263,  263,  263,  263,  263,  263,  263,  263,
      265,  265,  265,  265,  265,  265,  265,  265,  265,  265,
      265,  265,  265,  265,  265,  265,  265,  265,  263,  263,
      263,   60,   60,   60,   60,   60,   60,   60,   58,   60,
       60,   60,   60,   60,   60,   60,   60,   60,   60,  151,

       60,   60,   60,   60,   60,   60,   60,  263,  263,  263,
      266,  267,  266,  266,  267,  266,  266,  266,  266,  266,
      266,  266,  266,  266,  266,  266,  266,  268,  268,  268,
      268,  268,  268,  268,  268,  268,  268,  268,  268,  268,
      268,  268,  268,  268,  268,  266,  266,  266,   60,   60,
       60,   60,   60,   60,   60,   58,   60,   60,   60,   60,
       60,   60,   60,   60,   60,   60,  151,   60,   60,   60,
       60,   60,   60,   60,  266,  266,  266,  269,  270,  269,
      269,  270,  269,  269,  269,  269,  269,  269,  269,  269,
      269,  269,  269,  269,  271,  271,  271,  271,  271,  271,

      271,  271,  271,  271,  271,  271,  271,  271,  271,  271,
      271,  271,  269,  269,  269,   60,   60,   60,   60,   60,
       60,   60,   58,   60,   60,   60,   60,   60,   60,   60,
       60,   60,   60,  151,   60,   60,   60,   60,   60,   60,
       60,  269,  269,  269,  328,  329,  328,  328,  329,  328,
      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  330,  330,  330,  330,  330,  330,  330,  330,  330,
      330,  330,  330,  330,  330,  330,  330,  330,  330,  328,
      328,  328,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,

       58,   58,   58,   58,   58,   58,   58,   58,  328,  328,
      328,  376,  377,  376,  376,  377,  376,  376,  376,  376,
      376,  376,  376,  376,  376,  376,  376,  376,  378,  378,
      378,  378,  378,  378,  378,  378,  378,  378,  378,  378,
      378,  378,  378,  378,  378,  378,  376,  376,  376,   60,
       60,   60,   60,   60,   60,   60,   58,  379,   60,   60,
       60,   60,   60,   60,   60,   60,   60,  151,   60,   60,
       60,   60,   60,   60,   60,  376,  376,  376,  395,  396,
      395,  395,  396,  395,  395,  395,  395,  395,  395,  395,
      395,  395,  395,  395,  395,  397,  397,  397,  397,  397,

      397,  397,  397,  397,  397,  397,  397,  397,  397,  397,
      397,  397,  397,  395,  395,  395,   60,   60,   60,   60,
       60,   60,   60,   58,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,  151,   60,   60,   60,   60,   60,
       60,   60,  395,  395,  395,  429,  430,  429,  429,  430,
      429,  429,  429,  429,  429,  429,  429,  429,  429,  429,
      429,  429,  431,  431,  431,  431,  431,  431,  431,  431,
      431,  431,  431,  431,  431,  431,  431,  431,  431,  431,
      429,  429,  429,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,

       58,   58,   58,   58,   58,   58,   58,   58,   58,  429,
      429,  429,  434,  435,  434,  434,  435,  434,  434,  434,
      434,  434,  434,  434,  434,  434,  434,  434,  434,  436,
      436,  436,  436,  436,  436,  436,  436,  436,  436,  436,
      436,  436,  436,  436,  436,  436,  436,  434,  434,  434,
       60,   60,   60,   60,   60,   60,   60,   58,   60,   60,
      249,   60,   60,   60,   60,   60,   60,   60,  151,   60,
       60,   60,   60,   60,   60,   60,  434,  434,  434,  438,
      439,  438,  438,  439,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  440,  440,  440,  440,

      440,  440,  440,  440,  440,  440,  440,  440,  440,  440,
      440,  440,  440,  440,  438,  438,  438,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,  438,  438,  438,  442,  443,  442,  442,
      443,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  442,  442,  442,   60,   60,   60,   60,   60,   60,
       60,   58,   60,   60,   60,   60,   60,   60,   60,   60,

       60,   60,  151,   60,   60,   60,   60,   60,   60,   60,
      442,  442,  442,  447,  448,  447,  447,  448,  447,  447,
      447,  447,  447,  447,  447,  447,  447,  447,  447,  447,
      449,  449,  449,  449,  449,  449,  449,  449,  449,  449,
      449,  449,  449,  449,  449,  449,  449,  449,  447,  447,
      447,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,  447,  447,  447,
      450,  451,  450,  450,  451,  450,  450,  450,  450,  450,
      450,  450,  450,  450,  450,  450,  450,  452,  452,  452,

      452,  452,  452,  452,  452,  452,  452,  452,  452,  452,
      452,  452,  452,  452,  452,  450,  450,  450,   60,   60,
       60,   60,   60,   60,   60,   58,   60,   60,   60,   60,
       60,   60,   60,   60,   60,   60,  151,   60,   60,   60,
       60,   60,   60,   60,  450,  450,  450,   13,   13,   13,
       13,   68,   68,   68,   68,   97,  406,   97,   97,  121,
      121,  163,  405,  163,  163,  147,  147,  147,  272,  354,
      272,  272,  284,  387,  284,  284,  285,  385,  285,  285,
      286,  404,  286,  286,  291,  291,  291,  291,  294,  403,
      294,  294,  295,  402,  295,  295,  296,  401,  296,  296,

      252,  252,  252,  256,  256,  256,  263,  263,  263,  266,
      266,  266,  269,  269,  269,  341,  400,  341,  341,  342,
      342,  342,  342,  345,  399,  345,  345,  346,  394,  346,
      346,  347,  393,  347,  347,  349,  135,  349,  349,  351,
      326,  351,  351,  328,  328,  328,  376,  376,  376,  395,
      395,  395,  429,  429,  429,  434,  434,  434,  438,  438,
      438,  442,  442,  442,  447,  447,  447,  450,  450,  450,
      234,  234,  315,  392,  308,  308,  391,  390,  387,  389,
      388,  387,  354,  386,  385,  350,  343,  382,  381,  380,
      375,  374,  373,  372,  135,  371,  326,  370,  369,  368,

      367,  366,  234,  365,  364,  308,  363,  362,  361,  360,
      135,  359,  354,  358,  357,  356,  355,  354,  353,  352,
      350,  292,  340,  339,  338,  337,  336,  335,  334,  333,
      332,  331,  327,  326,  325,  324,  323,  322,  321,  320,
      319,  318,  317,  316,  234,  315,  314,  313,  308,  135,
      312,  311,  310,  308,  135,  309,  308,  307,  306,  305,
      302,  301,  300,  172,  299,  298,  297,  290,  194,  289,
      288,  287,  283,  282,  279,  278,  277,  276,  275,  172,
      262,  261,  260,  255,  251,  250,  249,  248,  247,  246,
      243,  242,  239,  238,  235,  234,  233,  135,  232,  231,

      230,  229,  228,  227,  226,  225,  224,  223,  222,  221,
      220,  215,  162,  157,  156,  155,  150,  205,  204,  203,
      202,  201,  199,  187,  186,  182,  181,  162,  161,  157,
      156,  155,  150,  146,  145,  144,  143,  138,  137,  134,
      123,  122,  120,  119,   54,   54,   54,   54,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,

      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453
    } ;

static short int c[1916] =
    {   0,
        0,    1,    1,    1,    1,    2,    2,    2,    2,    3,
        3,    3,    3,    0,    0,    3,    3,    4,    4,    4,
        4,   72,   78,    4,    4,    5,    5,    5,    5,   76,
        5,    6,    6,    6,    6,   78,    6,    7,    7,    7,
        7,   72,    0,    3,    6,    8,    8,    8,    8,   12,
       14,    4,   12,   14,   17,  441,   76,   17,    8,    5,
       25,   28,   45,   25,   28,    6,   34,   41,   43,   34,
       45,   43,    3,    3,    3,   53,   55,   41,   53,   55,
        4,    4,    4,    9,    9,    9,    9,   40,    9,    9,
        9,   42,  437,   42,   40,   61,   65,   48,   48,   61,

       61,   40,   74,   42,   65,   74,   34,   34,   65,   48,
       75,   34,   48,   88,   34,   73,   73,    9,   88,   73,
       81,   73,   77,   34,   90,   73,   73,   73,   84,   85,
       75,   77,   77,   90,   81,   75,   85,   85,   84,   87,
      115,   84,  115,   86,   81,   81,    9,    9,    9,   10,
       10,   10,   10,  432,   10,   10,   10,   86,   87,   96,
       86,   87,   10,   86,  110,   87,  104,   96,  427,   86,
      104,  104,  110,  116,  106,  106,  110,  138,  106,  141,
      106,  116,  144,   10,  106,  106,  106,  164,  148,  218,
      138,  148,  144,  164,  184,  184,  141,  184,  198,  218,

      198,  253,  257,  264,  253,  257,  264,  267,  270,  425,
      267,  270,   10,   10,   10,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   20,  424,   20,   20,   20,   20,  280,  280,
      329,  280,  422,  329,  421,   20,   20,   20,   20,   20,

       20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
       20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
       20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
       20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
       20,   20,   20,   20,   20,   27,  111,  113,   27,  111,
      113,  278,  293,   27,   27,  344,  348,  373,  373,  377,
      396,  399,  377,  396,  420,  278,  293,  399,  416,  344,
      348,  416,  430,  435,  439,  430,  435,  439,  419,   27,
      418,   27,  111,   27,   27,   27,   27,  113,  113,  417,
      443,  448,  113,  443,  448,  113,   27,  415,   27,   27,

       27,   27,  451,  414,  113,  451,   27,   27,   27,   29,
       29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
       29,   29,   29,   29,   29,  413,   29,  412,  411,  410,
       29,  409,  408,  407,   29,  406,  405,  404,  403,  402,
      401,  400,   29,  398,  394,  393,  392,   29,   29,   32,
       32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
       32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
       32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
       32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
       32,   32,   32,   32,   32,   32,   32,   32,   32,   32,

       32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
       32,   32,   32,   32,   32,   32,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   60,   60,   60,   60,   60,   60,   60,
      391,   60,   60,   60,   60,   60,   60,   60,   60,   60,

       60,   60,   60,   60,   60,   60,   60,   60,   60,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  156,  156,  156,  156,
      156,  156,  156,  156,  156,  156,  156,  156,  156,  156,
      156,  156,  156,  156,  156,  156,  156,  156,  156,  156,

      156,  156,  156,  156,  156,  156,  156,  156,  156,  156,
      156,  156,  156,  156,  156,  156,  156,  156,  156,  156,
      156,  156,  156,  156,  156,  156,  156,  156,  156,  156,
      156,  156,  156,  156,  156,  156,  156,  156,  156,  156,
      156,  156,  156,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,

      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,

      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  248,  248,  248,  248,  248,  248,
      248,  248,  248,  248,  248,  248,  248,  248,  248,  248,
      248,  248,  248,  248,  248,  248,  248,  248,  248,  248,
      248,  248,  248,  248,  248,  248,  248,  248,  248,  248,
      248,  248,  248,  248,  248,  248,  248,  248,  248,  248,
      248,  248,  248,  248,  248,  248,  248,  248,  248,  248,

      248,  248,  248,  248,  248,  248,  248,  248,  248,  248,
      248,  335,  335,  335,  335,  335,  335,  335,  335,  335,
      335,  335,  335,  335,  335,  335,  335,  335,  335,  335,
      335,  335,  335,  335,  335,  335,  335,  335,  335,  335,
      335,  335,  335,  335,  335,  335,  335,  335,  335,  335,
      335,  335,  335,  335,  335,  335,  335,  335,  335,  335,
      335,  335,  335,  335,  335,  335,  335,  335,  335,  335,
      335,  335,  335,  335,  335,  335,  335,  335,  372,  372,
      372,  372,  372,  372,  372,  372,  372,  372,  372,  372,
      372,  372,  372,  372,  372,  372,  372,  372,  372,  372,

      372,  372,  372,  372,  372,  372,  372,  372,  372,  372,
      372,  372,  372,  372,  372,  372,  372,  372,  372,  372,
      372,  372,  372,  372,  372,  372,  372,  372,  372,  372,
      372,  372,  372,  372,  372,  372,  372,  372,  372,  372,
      372,  372,  372,  372,  372,  423,  423,  423,  423,  423,
      423,  423,  423,  423,  423,  423,  423,  423,  423,  423,
      423,  423,  423,  423,  423,  423,  423,  423,  423,  423,
      423,  423,  423,  423,  423,  423,  423,  423,  423,  423,
      423,  423,  423,  423,  423,  423,  423,  423,  423,  423,
      423,  423,  423,  423,  423,  423,  423,  423,  423,  423,

      423,  423,  423,  423,  423,  423,  423,  423,  423,  423,
      423,  423,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,

      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  433,  433,  433,  433,
      433,  433,  433,  433,  433,  433,  433,  433,  433,  433,
      433,  433,  433,  433,  433,  433,  433,  433,  433,  433,
      433,  433,  433,  433,  433,  433,  433,  433,  433,  433,
      433,  433,  433,  433,  433,  433,  433,  433,  433,  433,
      433,  433,  433,  433,  433,  433,  433,  433,  433,  433,

      433,  433,  433,  433,  433,  433,  433,  433,  433,  433,
      433,  433,  433,  445,  445,  445,  445,  445,  445,  445,
      445,  445,  445,  445,  445,  445,  445,  445,  445,  445,
      445,  445,  445,  445,  445,  445,  445,  445,  445,  445,
      445,  445,  445,  445,  445,  445,  445,  445,  445,  445,
      445,  445,  445,  445,  445,  445,  445,  445,  445,  445,
      445,  445,  445,  445,  445,  445,  445,  445,  445,  445,
      445,  445,  445,  445,  445,  445,  445,  445,  445,  445,
      446,  446,  446,  446,  446,  446,  446,  446,  446,  446,
      446,  446,  446,  446,  446,  446,  446,  446,  446,  446,

      446,  446,  446,  446,  446,  446,  446,  446,  446,  446,
      446,  446,  446,  446,  446,  446,  446,  446,  446,  446,
      446,  446,  446,  446,  446,  446,  446,  446,  446,  446,
      446,  446,  446,  446,  446,  446,  446,  446,  446,  446,
      446,  446,  446,  446,  446,  446,  446,  454,  454,  454,
      454,  455,  455,  455,  455,  456,  390,  456,  456,  457,
      457,  458,  389,  458,  458,  459,  459,  459,  460,  388,
      460,  460,  461,  386,  461,  461,  462,  385,  462,  462,
      463,  382,  463,  463,  464,  464,  464,  464,  465,  381,
      465,  465,  466,  380,  466,  466,  467,  379,  467,  467,

      468,  468,  468,  469,  469,  469,  470,  470,  470,  471,
      471,  471,  472,  472,  472,  473,  375,  473,  473,  474,
      474,  474,  474,  475,  374,  475,  475,  476,  371,  476,
      476,  477,  370,  477,  477,  478,  369,  478,  478,  479,
      368,  479,  479,  480,  480,  480,  481,  481,  481,  482,
      482,  482,  483,  483,  483,  484,  484,  484,  485,  485,
      485,  486,  486,  486,  487,  487,  487,  488,  488,  488,
      367,  366,  365,  364,  363,  362,  361,  360,  359,  358,
      357,  356,  355,  353,  352,  350,  342,  338,  337,  336,
      334,  333,  332,  331,  327,  325,  324,  323,  322,  321,

      320,  319,  318,  317,  316,  314,  313,  312,  311,  310,
      309,  307,  306,  305,  304,  303,  302,  301,  300,  299,
      297,  291,  274,  273,  262,  261,  260,  259,  255,  251,
      250,  249,  247,  246,  245,  244,  243,  242,  241,  240,
      239,  238,  237,  236,  235,  233,  232,  231,  230,  229,
      228,  227,  226,  225,  224,  223,  222,  221,  220,  219,
      217,  216,  215,  213,  207,  206,  205,  197,  196,  195,
      193,  192,  187,  185,  183,  182,  177,  175,  174,  171,
      159,  158,  157,  155,  153,  152,  151,  150,  146,  145,
      143,  142,  140,  139,  137,  136,  134,  133,  132,  131,

      130,  129,  128,  127,  126,  125,  124,  123,  122,  118,
      117,  114,  112,  109,  108,  105,  101,   95,   94,   93,
       92,   91,   89,   83,   82,   80,   79,   67,   66,   64,
       63,   62,   59,   52,   51,   50,   49,   47,   46,   44,
       39,   38,   36,   35,   31,   24,   18,   15,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,

      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453
    } ;


/* these declarations have to come after the section 1 code or lint gets
 * confused about whether the variables are used
 */
FILE *yyin = stdin, *yyout = stdout;

/* these variables are all declared out here so that section 3 code can
 * manipulate them
 */
static int yy_start = 0, yy_b_buf_p, yy_c_buf_p, yy_e_buf_p;
static int yy_saw_eof, yy_init = 1;

/* yy_ch_buf has to be 1 character longer than YY_BUF_SIZE, since when
 * setting up yytext we can try to put a '\0' just past the end of the
 * matched text
 */
static char yy_ch_buf[YY_BUF_SIZE + 1];
static int yy_st_buf[YY_BUF_SIZE];
static char yy_hold_char;
char *yytext;
static int yyleng;

YY_DECL
    {
    int yy_n_chars, yy_lp, yy_iii, yy_buf_pos, yy_act;
#ifdef FLEX_REJECT_ENABLED
    int yy_full_match;
#endif




    if ( yy_init )
	{
	YY_INIT;
	if (!yy_start) yy_start = 1;
	yy_init = 0;
	}

    goto get_next_token;

do_action:

#ifdef FLEX_REJECT_ENABLED
    /* remember matched text in case we back up due to trailing context */
    yy_full_match = yy_c_buf_p;
#endif

    for ( ; ; )
	{
	YY_DO_BEFORE_ACTION

#ifdef FLEX_DEBUG
	fprintf( stderr, "--accepting rule #%d\n", yy_act );
#endif
	switch ( yy_act )
	    {
case 1:
# line 112 "xfmt.l"
skipline(1);
	YY_BREAK
/* match various TeX skip commands */
case 2:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 115 "xfmt.l"
skipline(1);
	YY_BREAK
/* blank line in input gives blank line in output -- not like real TeX */
case 3:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p = yy_b_buf_p;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 118 "xfmt.l"
skipline(1);
	YY_BREAK
case 4:
# line 120 "xfmt.l"
skipline(atoi(yytext+4));
	YY_BREAK
/* traditional */
case 5:
# line 123 "xfmt.l"
{
			lbreak();
			(void)printf("%s\n",yytext);
}
	YY_BREAK
/* escaped special characters -- \\ for \ not like real TeX */
case 6:
# line 129 "xfmt.l"
puttc(yytext[1]);
	YY_BREAK
/* some font-changing commands */
case 7:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 134 "xfmt.l"
case 8:
# line 134 "xfmt.l"
attribute = ITALIC;
	YY_BREAK
case 9:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 137 "xfmt.l"
case 10:
# line 137 "xfmt.l"
attribute = SLANTY;
	YY_BREAK
case 11:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 140 "xfmt.l"
case 12:
# line 140 "xfmt.l"
attribute = BOLD;
	YY_BREAK
case 13:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 143 "xfmt.l"
case 14:
# line 143 "xfmt.l"
attribute = ROMAN; /* \fP should not be like \fR */
	YY_BREAK
case 15:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 146 "xfmt.l"
case 16:
# line 146 "xfmt.l"
attribute = TTYPE;
	YY_BREAK
case 17:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 149 "xfmt.l"
putts("TeX");
	YY_BREAK
/* should these 4 TeX commands cause breaks? */
case 18:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 152 "xfmt.l"
ceflag = TRUE;
	YY_BREAK
case 19:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 154 "xfmt.l"
raflag = TRUE;
	YY_BREAK
case 20:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 156 "xfmt.l"
njflag = level;
	YY_BREAK
case 21:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 158 "xfmt.l"
obflag = level;
	YY_BREAK
case 22:
# line 160 "xfmt.l"
lbreak(); obflag = TRUE;
	YY_BREAK
case 23:
# line 162 "xfmt.l"
lbreak(); obflag = FALSE;
	YY_BREAK
case 24:
# line 164 "xfmt.l"
nest[level++] = attribute; /* push attr. onto stack */
	YY_BREAK
case 25:
# line 166 "xfmt.l"
{		/* if emerging from {} in which \obeylines or
			 * \raggedright occurred, cancel  (not a very general
			 * strategy)
			 */
			if (obflag == level) obflag = FALSE;
			if (njflag == level) njflag = FALSE;
			/* pop attribute off stack */
			if (level > 1) attribute = nest[--level];
			/* } after \item signals end of tag; will not
			 * work right with {} inside tag */
			if (tpstate == 1)  {
				tpstate = 2;
				putword();
			}
}
	YY_BREAK
case 26:
# line 183 "xfmt.l"
{
			putword();
			if (iflag || obflag) {
				putline();
				tempi = attribute;
				/* for comments with indentation */
				if (cflag) attribute = ROMAN;
				copyindent(yytext);
				attribute = tempi;
			}
			else if (mflag)
				putline();
}
	YY_BREAK
case 27:
# line 197 "xfmt.l"
putword();
	YY_BREAK
case 28:
# line 199 "xfmt.l"
{	/* for C code reverse all of multiline comments */
			if (!cflag) attribute = ROMAN;
			nextattribute = qtflag = FALSE;
			/* signal end of tag for hanging indent */
			if (tpstate == 1) tpstate = 2;
			putword();
			if (obflag) putline();
}
	YY_BREAK
/* more font-changing */
case 29:
# line 210 "xfmt.l"
attribute = BOLD;
	YY_BREAK
case 30:
# line 212 "xfmt.l"
attribute = ITALIC;
	YY_BREAK
case 31:
# line 214 "xfmt.l"
attribute = ROMAN;
	YY_BREAK
case 32:
# line 216 "xfmt.l"
attribute = TTYPE;
	YY_BREAK
case 33:
# line 218 "xfmt.l"
attribute = SLANTY;
	YY_BREAK
case 34:
# line 220 "xfmt.l"
;
	YY_BREAK
case 35:
# line 222 "xfmt.l"
puttc(yytext[1]);
	YY_BREAK
case 36:
# line 224 "xfmt.l"
{
	 		lbreak();
			for (tempi = 0; tempi < atoi(yytext+5) - 1; tempi++)
				puttc(' ');
}
	YY_BREAK
case 37:
# line 230 "xfmt.l"
lbreak();
	YY_BREAK
case 38:
# line 232 "xfmt.l"
skipline(1); indent = 5;
	YY_BREAK
/* hanging indent stuff (awfully complicated) */
case 39:
# line 236 "xfmt.l"
{
			skipline(1);
			if (yytext[1] == 'H')
				tpstate = 4;
			else	tpstate = 1;
			tpvalue = atoi(yytext+4);
			indent = 5;
}
	YY_BREAK
case 40:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 246 "xfmt.l"
case 41:
# line 247 "xfmt.l"
case 42:
# line 248 "xfmt.l"
case 43:
# line 248 "xfmt.l"
{
			skipline(1);
			if (yytext[1] == 'I' && yytext[3] == '\n')
				tpstate = 4;
			else	tpstate = 1;
			tpvalue = 5;
			indent = 5;
}
	YY_BREAK
/* various begin-end commands to set off blocks of text */
case 44:
# line 259 "xfmt.l"
{
			if (yytext[1] == 'D' && yytext[2] == 'S') {
				skipline(1);
				obflag = TRUE;
			}
			else	lbreak();
			indent = 10;
			if (yytext[2] == 'E') {
				indent = 5;
				obflag = FALSE;
			}
}
	YY_BREAK
case 45:
# line 272 "xfmt.l"
{
			skipline(1);
			if (yytext[2] == 'E') {
				indent = 5;
				obflag = FALSE;
			}
			else {	indent = 10;
				obflag = TRUE;
			}
}
	YY_BREAK
case 46:
# line 284 "xfmt.l"
{
			skipline(1);
			if (yytext[2] == 'E') {
				indent = 5;
				maxlen += 5;
			}
			else {	indent = 10;
				maxlen -= 5;
				tempi = attribute;
				attribute = ITALIC;
				ceflag = TRUE;
				if (yyleng < 5) putts("NOTE");
				else putts(yytext+4);
				skipline(1);
			}
}
	YY_BREAK
/* those curious -man commands to join words, alternating fonts */
case 47:
# line 303 "xfmt.l"
nextattribute = ROMAN; attribute = ITALIC;
	YY_BREAK
case 48:
# line 305 "xfmt.l"
nextattribute = ROMAN; attribute = BOLD;
	YY_BREAK
case 49:
# line 307 "xfmt.l"
nextattribute = ITALIC; attribute = ROMAN;
	YY_BREAK
case 50:
# line 309 "xfmt.l"
nextattribute = ITALIC; attribute = BOLD;
	YY_BREAK
case 51:
# line 311 "xfmt.l"
nextattribute = BOLD; attribute = ROMAN;
	YY_BREAK
case 52:
# line 313 "xfmt.l"
nextattribute = BOLD; attribute = ITALIC;
	YY_BREAK
/* section headings */
case 53:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 317 "xfmt.l"
{
			skipline(1);
			nextattribute = attribute;
			attribute = BOLD;
}
	YY_BREAK
case 54:
# line 323 "xfmt.l"
{
			skipline(1);
			if (yytext[2] == 'H')
				indent = 0;
			attribute = BOLD;
			putts(yytext+4);
			lbreak();
			indent = 5;
			attribute = ROMAN;
}
	YY_BREAK
case 55:
# line 334 "xfmt.l"
{
			lbreak();
			indent = 0;
			addparens(yytext+4, BOLD);
			raflag = TRUE;
			skipline(2);
			indent = 5;
}
	YY_BREAK
/* "Manual Section" reference */
case 56:
# line 344 "xfmt.l"
addparens(yytext+4, ITALIC);
	YY_BREAK
case 57:
# line 346 "xfmt.l"
{
			if (uflag || oflag) {
				tempi = attribute;
				attribute = TTYPE;
				puttc(toupper(yytext[4]));
				attribute = tempi;
			}
			else {
				putts("<CTRL/");
				puttc(yytext[4]);
				puttc('>');
			}
}
	YY_BREAK
case 58:
# line 361 "xfmt.l"
case 59:
# line 362 "xfmt.l"
case 60:
# line 362 "xfmt.l"
;
	YY_BREAK
/* for join-words commands, words can be quoted */
case 61:
# line 365 "xfmt.l"
{
			if (nextattribute || tpstate == 1)  {
				qtflag = !qtflag;
			}
			else puttc('"');
}
	YY_BREAK
case 62:
# line 372 "xfmt.l"
{
			if (nextattribute)  {
				if (qtflag) puttc(' ');
				else  {
					tempi = attribute;
					attribute = nextattribute;
					nextattribute = tempi;
				}
			}
			else {
				putword();
				if (obflag) copyindent(yytext);
			}
}
	YY_BREAK
case 63:
# line 387 "xfmt.l"
{
			putword();
			if (obflag || nextattribute) putline();
			if (nextattribute) {
				attribute = nextattribute;
				nextattribute = 0;
			}
}
	YY_BREAK
case 64:
# line 396 "xfmt.l"
puttc(' ');
	YY_BREAK
case 65:
# line 398 "xfmt.l"
{
			putword();
			if (obflag) copyindent(yytext);
}
	YY_BREAK
case 66:
# line 403 "xfmt.l"
putword();
	YY_BREAK
case 67:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 405 "xfmt.l"
puttc('\\');
	YY_BREAK
case 68:
# line 408 "xfmt.l"
case 69:
# line 408 "xfmt.l"
;
	YY_BREAK
case 70:
YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */
yy_c_buf_p -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
# line 410 "xfmt.l"
;
	YY_BREAK
case 71:
# line 412 "xfmt.l"
puttc('\'');
	YY_BREAK
case 72:
# line 414 "xfmt.l"
puttc('`');
	YY_BREAK
case 73:
# line 416 "xfmt.l"
{
			tempi = attribute;
			attribute = TTYPE;
			if (yytext[2] != '*') puttc(yytext[2]);
			puttc(yytext[3]);
			attribute = tempi;
}
	YY_BREAK
case 74:
# line 425 "xfmt.l"
case 75:
# line 426 "xfmt.l"
case 76:
# line 427 "xfmt.l"
case 77:
# line 428 "xfmt.l"
case 78:
# line 429 "xfmt.l"
case 79:
# line 429 "xfmt.l"
;
	YY_BREAK
case 80:
# line 431 "xfmt.l"
{	if (attribute != TTYPE) qtflag = !qtflag;
			puttc('"');
}
	YY_BREAK
case 81:
# line 435 "xfmt.l"
{	puttc('/');
			if (!qtflag) attribute = TTYPE;
			puttc('*');
}
	YY_BREAK
case 82:
# line 440 "xfmt.l"
{	puttc('*');
			if (!qtflag) attribute = ROMAN;
			puttc('/');
}
	YY_BREAK
/* control flow keywords are bold */
case 83:
# line 447 "xfmt.l"
case 84:
# line 447 "xfmt.l"
{
			if (attribute != TTYPE && !qtflag) {
				attribute = BOLD;
				putts(yytext);
				attribute = ROMAN;
			} else putts(yytext);
}
	YY_BREAK
/* storage class keywords are underlined */
case 85:
# line 457 "xfmt.l"
case 86:
# line 458 "xfmt.l"
case 87:
# line 458 "xfmt.l"
{

			if (attribute != TTYPE && !qtflag) {
				attribute = ITALIC;
				putts(yytext);
				attribute = ROMAN;
			} else putts(yytext);
}
	YY_BREAK
/* preprocessor keywords are blinking */
case 88:
# line 469 "xfmt.l"
case 89:
# line 469 "xfmt.l"
{

			if (attribute != TTYPE && !qtflag) {
				attribute = SLANTY;
				putts(yytext);
				attribute = ROMAN;
			} else putts(yytext);
}
	YY_BREAK
/* identifiers that happen to contain keywords are plain */
case 90:
# line 479 "xfmt.l"
putts(yytext);
	YY_BREAK
case 91:
# line 481 "xfmt.l"
puttc(yytext[0]);
	YY_BREAK

case YY_NEW_FILE:
break; /* begin reading from new file */

case YY_DO_DEFAULT:
YY_DEFAULT_ACTION;
break;

case YY_END_TOK:
return ( YY_END_TOK );

default:
YY_FATAL_ERROR( "fatal flex scanner internal error" );
	    }

get_next_token:
	{
	register int yy_curst;
	register char yy_sym;

	YY_DO_BEFORE_SCAN

	/* set up to begin running DFA */

	yy_curst = yy_start;

	if ( yy_ch_buf[yy_c_buf_p] == '\n' )
	    ++yy_curst;

	/* yy_b_buf_p points to the position in yy_ch_buf
	 * of the start of the current run.
	 */

	yy_b_buf_p = yy_c_buf_p + 1;

	do /* until the machine jams */
	    {
	    if ( yy_c_buf_p == yy_e_buf_p )
		{ /* need more input */
		if ( yy_e_buf_p >= YY_BUF_LIM )
		    { /* not enough room to do another read */
		    /* see if we can make some room for more chars */

		    yy_n_chars = yy_e_buf_p - yy_b_buf_p;

		    if ( yy_n_chars >= 0 )
			/* shift down buffer to make room */
			for ( yy_iii = 0; yy_iii <= yy_n_chars; ++yy_iii )
			    {
			    yy_buf_pos = yy_b_buf_p + yy_iii;
			    yy_ch_buf[yy_iii] = yy_ch_buf[yy_buf_pos];
			    yy_st_buf[yy_iii] = yy_st_buf[yy_buf_pos];
			    }

		    yy_b_buf_p = 0;
		    yy_e_buf_p = yy_n_chars;

		    if ( yy_e_buf_p >= YY_BUF_LIM )
			YY_FATAL_ERROR( "flex input buffer overflowed" );

		    yy_c_buf_p = yy_e_buf_p;
		    }

		else if ( yy_saw_eof )
		    {
saweof:		    if ( yy_b_buf_p > yy_e_buf_p )
			{
			if ( yywrap() )
			    {
			    yy_act = YY_END_TOK;
			    goto do_action;
			    }
			
			else
			    {
			    YY_INIT;
			    yy_act = YY_NEW_FILE;
			    goto do_action;
			    }
			}

		    else /* do a jam to eat up more input */
			{
#ifndef FLEX_INTERACTIVE_SCANNER
			/* we're going to decrement yy_c_buf_p upon doing
			 * the jam.  In this case, that's wrong, since
			 * it points to the last non-jam character.  So
			 * we increment it now to counter the decrement.
			 */
			++yy_c_buf_p;
#endif
			break;
			}
		    }

		YY_INPUT( (yy_ch_buf + yy_c_buf_p + 1), yy_n_chars,
			  YY_MAX_LINE );

		if ( yy_n_chars == YY_NULL )
		    {
		    if ( yy_saw_eof )
	YY_FATAL_ERROR( "flex scanner saw EOF twice - shouldn't happen" );
		    yy_saw_eof = 1;
		    goto saweof;
		    }

		yy_e_buf_p += yy_n_chars;
		}

	    ++yy_c_buf_p;

#ifdef FLEX_USE_ECS
	    yy_sym = e[yy_ch_buf[yy_c_buf_p]];
#else
	    yy_sym = yy_ch_buf[yy_c_buf_p];
#endif

#ifdef FLEX_FULL_TABLE
	    yy_curst = n[yy_curst][yy_sym];

#else /* get next state from compressed table */

	    while ( c[b[yy_curst] + yy_sym] != yy_curst )
		{
		yy_curst = d[yy_curst];

#ifdef FLEX_USE_MECS
		/* we've arrange it so that templates are never chained
		 * to one another.  This means we can afford make a
		 * very simple test to see if we need to convert to
		 * yy_sym's meta-equivalence class without worrying
		 * about erroneously looking up the meta-equivalence
		 * class twice
		 */

		if ( yy_curst >= YY_TEMPLATE )
		    yy_sym = m[yy_sym];
#endif
		}

	    yy_curst = n[b[yy_curst] + yy_sym];

#endif

	    yy_st_buf[yy_c_buf_p] = yy_curst;

	    }
#ifdef FLEX_INTERACTIVE_SCANNER
	while ( b[yy_curst] != YY_JAM_BASE );
#else
	while ( yy_curst != YY_JAM );
	--yy_c_buf_p; /* put back character we jammed on */

#endif

	if ( yy_c_buf_p >= yy_b_buf_p )
	    { /* we matched some text */
	    yy_curst = yy_st_buf[yy_c_buf_p];
	    yy_lp = l[yy_curst];

#ifdef FLEX_REJECT_ENABLED
find_rule: /* we branch to this label when doing a REJECT */
#endif

	    for ( ; ; ) /* until we find what rule we matched */
		{
#ifdef FLEX_REJECT_ENABLED
		if ( yy_lp && yy_lp < l[yy_curst + 1] )
		    {
		    yy_act = a[yy_lp];
		    goto do_action; /* "continue 2" */
		    }
#else
		if ( yy_lp )
		    {
		    yy_act = yy_lp;
		    goto do_action; /* "continue 2" */
		    }
#endif

		if ( --yy_c_buf_p < yy_b_buf_p )
		    break;

		yy_curst = yy_st_buf[yy_c_buf_p];
		yy_lp = l[yy_curst];
		}
	    }

	/* if we got this far, then we didn't find any accepting
	 * states
	 */

	/* so that the default applies to the first char read */
	++yy_c_buf_p;

	yy_act = YY_DO_DEFAULT;
	}
	}

    /*NOTREACHED*/
    }


static int unput( c )
char c;

    {
    YY_DO_BEFORE_SCAN; /* undo effects of setting up yytext */

    if ( yy_c_buf_p == 0 )
	{
	register int i;
	register int yy_buf_pos = YY_BUF_MAX;

	for ( i = yy_e_buf_p; i >= yy_c_buf_p; --i )
	    {
	    yy_ch_buf[yy_buf_pos] = yy_ch_buf[i];
	    yy_st_buf[yy_buf_pos] = yy_st_buf[i];
	    --yy_buf_pos;
	    }

	yy_c_buf_p = YY_BUF_MAX - yy_e_buf_p;
	yy_e_buf_p = YY_BUF_MAX;
	}

    if ( yy_c_buf_p <= 0 )
	YY_FATAL_ERROR( "flex scanner push-back overflow" );

    if ( yy_c_buf_p >= yy_b_buf_p && yy_ch_buf[yy_c_buf_p] == '\n' )
	yy_ch_buf[yy_c_buf_p - 1] = '\n';

    yy_ch_buf[yy_c_buf_p--] = c;

    YY_DO_BEFORE_ACTION; /* set up yytext again */
    }


static int input()

    {
    int c;

    YY_DO_BEFORE_SCAN

    if ( yy_c_buf_p == yy_e_buf_p )
	{ /* need more input */
	int yy_n_chars;

	/* we can throw away the entire current buffer */
	if ( yy_saw_eof )
	    {
	    if ( yywrap() )
		return ( EOF );

	    YY_INIT;
	    }

	yy_b_buf_p = 0;
	YY_INPUT( yy_ch_buf, yy_n_chars, YY_MAX_LINE );

	if ( yy_n_chars == YY_NULL )
	    {
	    yy_saw_eof = 1;

	    if ( yywrap() )
		return ( EOF );

	    YY_INIT;

	    return ( input() );
	    }

	yy_c_buf_p = -1;
	yy_e_buf_p = yy_n_chars - 1;
	}

    c = yy_ch_buf[++yy_c_buf_p];

    YY_DO_BEFORE_ACTION;

    return ( c );
    }
# line 485 "xfmt.l"


/*
 * Characters, along with the currently active "font"= screen
 * attribute, are collected in a word buffer until we hit a
 * word break (white space), then moved to a line buffer.
 * Words are collected in the line buffer until we hit a line
 * break (end of paragraph) or the line is long enough, then
 * the line is output.
 */

main (argc, argv)
int     argc;
char   *argv[];
{
	int     c, i;

	progname = basename (argv[0]);
	while ((c = getopt (argc, argv, "ijcxmoul:p:t:")) != EOF)
		switch (c) {
			case 'i': iflag = TRUE; break;
			case 'j': jflag = TRUE; break;
			case 'c': cflag = TRUE; break;
			case 'x': xflag = TRUE; break;
			case 'm': mflag = TRUE; break;
			case 'o': oflag = TRUE; break;
			case 'u': uflag = TRUE; break;
			case 'l': maxlen = max (0, atoi (optarg));
				  break;
			case 'p': offset = max (0, atoi (optarg));
				  break;
			case 't': tabsize = max (1, atoi (optarg));
				  break;
			default: (void) fprintf (stderr, usage, progname);
				  exit (1);
				  break;
		}


/* set lex start state */
	if (xflag && mflag) {
		BEGIN (ALL);
	}
	else if (xflag) {
		BEGIN (TEX);
	}
	else if (mflag) {
		indent = 5;
		BEGIN (MAN);
	}
	else if (cflag) {
		obflag = TRUE;
		if (!oflag) uflag = TRUE;
		BEGIN (CCODE);
	}
	else {
		BEGIN (PLAIN);
	}

/* consult termcap for terminal controls */
	if (uflag)
		terminit ();


/* call lex scanner */
	if (optind >= argc) {
		(void) yylex ();
		lbreak ();
	}
	else
		for (; (optind < argc); optind++) {
			if (freopen (argv[optind], "r", yyin) != NULL) {
				/* unstructured -- couldn't find any other
				 * way to get flex to look at > 1 file */
				yy_init = 1;
				(void) yylex ();
				lbreak ();
			}
			else {
				(void) fprintf (stderr,
				    "Couldn't open file: %s", argv[optind]);
				exit (1);
			}
		}

	return (0);
}				/* main */


/* preserve spacing due to spaces or tabs */
void	copyindent (ilp)
char	*ilp;
{
	int     col;

	col = (olp - oline) + 1;

	for (; (isspace (*ilp)); col++) {
		if (*ilp++ == '\t')
			for (; (col % tabsize); col++) {
				*olp++ = ' ';
				*alp++ = (cflag) ? attribute : ROMAN;
			}
		*olp++ = ' ';
		*alp++ = (cflag) ? attribute : ROMAN;
	}
}				/* copyindent */

/* one character goes into word buffer */
void puttc (ch)
char    ch;
{
	*owp++ = ch;
	*awp++ = attribute;
}				/* puttc */

/* put string in word buffer (might have spaces) */
void putts (s)
char   *s;
{
	while (*s)
		puttc (*s++);
}				/* putts */

/* finish pending word and line and put it out (no justification) */
void lbreak () {
	putword ();
	putline ();
	tpstate = 0;
}				/* lbreak */

/* append pending word to line buffer */
void putword () {
	int     plen;
	char   *p;
	char   *q;
	static char     started = 0;

	/* just return if no characters have been accumulated yet */
	if (owp == oword) {
		/* this is for the special case in which a file
		 * starts with \n, which should count as  a "blank line"
		 */
		if (!started) {
			putchar ('\n');
			started = 1;
		}
		return;
	}
	started = 1;

	puttc ('\0');
	p = oword;
	q = aword;
	plen = strlen (p);

	/* ugly way to ignore "0.3i" arg of .IP */
	if (tpstate == 2 && *p == '0' && p[plen - 1] == 'i') {
		spaces = plen = 0;
		*p = '\0';
	}

	/* finish pending line if pending word won't fit */
	if (!obflag && (olp - oline) + spaces + plen > maxlen - indent) {
		if ((jflag) && (holecnt) && !njflag)
			justifyline ();
		putline ();
	}

	/* append spaces which were previously decided to go after
	 * last word put in line buffer */
	if (spaces) {
		/* don't use space inside tag of hanging indent to
		 * right justify */
		if (!tpstate || tpstate > 3)
			holeptr[++holecnt] = olp;
		/* if tag already padded out, permit justification
		 * of space after next word */
		if (tpstate == 3)
			tpstate = 4;
		for (; (spaces > 0); spaces--) {
			*olp++ = ' ';
			/* a matter of taste -- put just " = ROMAN"
			 * for no underlined spaces between words */
			*alp++ = (*(alp-1) == ITALIC && *q == ITALIC) ?
				ITALIC : ROMAN;
		}
	}

	/* figure spaces which should go after pending word which
	 * is just about to be appended in line buffer -- remember
	 * so they can be put before next word (cf. just above) */
	if (!obflag) spaces = 1 + endofsentence (p, plen);
	/* (but if spacing is being preserved, as signaled by
	 *  obflag, we don't want extra spaces) */

	/* append pending word in line buffer */
	while (*p) {
		*olp++ = *p++;
		*alp++ = *q++;
	}

	/* part of tortuous way of handling hanging indent */
		/* tpstate = 0: no hanging indent
		 *	     1: scanning tag to go in left margin
		 *	     2: have seen end of tag, time to
		 *		pad out tag to hanging indent value
		 *	     3: finished padding
		 *	     4: finished first line of hanging par.;
		 *		subsequent lines should be indented
		 *		to hanging indent value
		 */
	if (tpstate == 2) {	/* time to pad tag? */
		tpstate = 3;	/* signal padding done */
		if ((olp - oline) + spaces > tpvalue) /* will tag fit? */
			putline ();	/* no it won't, so start new line */
		else		/* yes it will, so pad it out */
			while ((olp - oline) + spaces < tpvalue)
				spaces++;
	}

	/* purge word buffer -- get ready for next word */
	owp = oword;
	awp = aword;
}				/* putword */


/* increase inter-word spacings for right justification */
void justifyline () {
	int     n;
	char   *fp,
	       *tp,
	       *fa,
	       *ta;

	dir = (!(dir));
	fp = olp - 1;
	fa = alp - 1;
	olp = &oline[maxlen - indent];
	alp = &aline[maxlen - indent];
	tp = olp - 1;
	ta = alp - 1;
	while (tp > fp) {
		while (fp >= holeptr[holecnt]) {
			*tp-- = *fp--;
			*ta-- = *fa--;
		}
		if (dir)
			n = ((tp - fp) - 1) / holecnt + 1;
		else
			n = (tp - fp) / holecnt;
		while (n--) {
			*tp-- = ' ';
			*ta-- = ta[1];
		}
		holecnt--;
	}
}				/* justifyline */


/* put out pending line in line buffer */
void putline ()
{
	if (ceflag) {
		spaces = max ((maxlen - (olp - oline)) / 2, 1) + offset;
		ceflag = FALSE;
	}
	else if (raflag) {
		spaces = max ((maxlen - (olp - oline)), 1) + offset;
		raflag = FALSE;
	}
	else	spaces = indent + offset;

	*olp = '\0';

	if (*oline)
		/* if -u or -x options, have to do it character
		 * by character */
		if (oflag || uflag)
			sputline ();
	else
			(void) printf ("%*s\n", spaces + strlen (oline), oline);

	/* purge line buffer -- get ready for new line */
	*oline = '\0';
	olp = oline;
	alp = aline;
	spaces = 0;
	holecnt = 0;

	/* if finished with first line of hanging par., increase
	 * left indent for subsequent lines */
	if (tpstate > 2) {
		indent = tpvalue + 5;
		tpstate = 4;
	}
}				/* putline */


/* display characters of line with overstriking or with special
 * terminal attributes */
void sputline () {
	char   *p;
	char   *q;
	char    last = ROMAN;

	if (spaces)
		(void) printf ("%*s", spaces, NULL);

	for (p = oline, q = aline; *p; p++, q++)
		if (uflag) {
			last = newattr (last, *q);
			(void) printf ("%c", *p);
		} else
		switch (*q) {
			case ROMAN: 
				(void) printf ("%c", *p);
				break;
			case BOLD: 
			case TTYPE: 
				if (*p == ' ')
					printf("%c", *p);
				else	(void) printf ("%c%c%c", *p, 8, *p);
				break;
			case ITALIC: 
			case SLANTY: 
				(void) printf ("_%c%c", 8, *p);
				break;
		}
	if (uflag)
		last = newattr (last, ROMAN);
	(void) printf ("\n");

}				/* sputline */

/* put blank lines */
void skipline (n)
int     n;
{
	lbreak ();
	for (; (n > 0); n--)
		(void) printf ("\n");
	if (xflag)
		indent = 0;
}				/* skipline */


/* decide how many spaces go after word */
int     endofsentence (p, plen)
char   *p;
int     plen;
{
	if (plen < 3)
		return (FALSE);
	if (!strchr (".:?!", *(p + plen - 1)))
		return (FALSE);
	if (abbr (p))
		return (FALSE);
	return (TRUE);
}				/* endofsentence */


/* detect "." which is not real end of sentence */
int     abbr (s)
char   *s;
{
	char   *p,
	       *q,
	       *r;

	while (*s == '(')
		s++;
	q = ".i.e.g.dr.mr.mrs.st.";
	for (; (*q); q++) {
		p = q;
		r = s;
		while ((*r) && (*p++ == (*r++ | 0x20)));
		if (!*r)
			return (TRUE);
	}
	return (FALSE);
}				/* abbr */



char   *basename (s)
char   *s;
{
	char   *p;

	if (p = strrchr (s, '/'))
		return (++p);
	else
		return (s);
}				/* basename */



int     max (a, b)
int     a,
        b;
{
	return ((a > b) ? a : b);
}				/* max */


/* put parentheses around number of manual section */
void addparens (s, a)
char   *s;
int     a;
{
	nextattribute = attribute;
	attribute = a;
	while (*s && *s != ' ')
		puttc (*s++);
	if (*s == ' ')
		s++, puttc ('(');
	while (*s && *s != ' ')
		puttc (*s++);
	if (*s == ' ')
		s++;
	puttc (')');
	attribute = nextattribute;
	nextattribute = 0;
	if (*s && isalpha (*s))
		puttc (' ');
	while (*s)
		puttc (*s++);
}				/* addparens */

/* terminal commands -- accessing routines */

/*
 *  following derived from:
 *  tcap v1.0 Enhanced terminal control program
 *  Author: Eric Lorenzo Lim
 *  Modified by: Becca Thomas and Rik Farrow
 *  (appeared in Nov. '87 Unix World)
 */

#define SO 0
#define SE 1
#define MB 2
#define MD 3
#define MR 4
#define MH 5
#define ME 6
#define US 7
#define UE 8
char   *id[] = {
	"so", "se", "mb", "md", "mr", "mh", "me", "us", "ue",
	(char *) NULL,
};

char   *area[50];
char    bp[1024],
        strbuf[1024];

/* get for later use terminal handling commands we need */
void terminit () {
	int     id_size = 0;
	char   *str,
	       *tmpptr;
	extern char    *getenv (), *tgetstr (), *tgoto ();

	if ((tmpptr = getenv ("TERM")) == (char *) NULL) {
		(void) fprintf (stderr, "xfmt: TERM variable not set\n");
		exit (1);
	}

	str = strbuf;

	if (tgetent (bp, tmpptr))
		while (id[id_size] != (char *) NULL) {
			area[id_size] = tgetstr (id[id_size], &str);
			if (area[id_size] == (char *) NULL)
				area[id_size] = "";
			id_size++;
		}


}				/* terminit */

/* put out a terminal handing command */
void termattr (i)
int     i;
{
	(void) printf ("%s", area[i]);
}				/* termattr */

/* check for change of "font" and send command to terminal
 * when there is a change */
int     newattr (l, a)
int     l,	/* last attribute */
        a;	/* new attribute */
{
	if (l != a) {
		if (l == BOLD || l == TTYPE || l == SLANTY)
			termattr (ME);
		else if (l == ITALIC)
			termattr (UE);

		switch (a) {
			case   BOLD:	termattr (MD); break;
			case ITALIC:	termattr (US); break;
			case  TTYPE:	termattr (MR); break;
			case SLANTY:	termattr (MB); break;
		}
	}
	return (a);
}				/* newattr */

